<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2007 Stefan Siebel <siebel.stefan@gmail.com>
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/

require_once(PATH_tslib.'class.tslib_pibase.php');
require_once(t3lib_extMgm::extPath('si_bibtex').'pi1/class.tx_sibibtex_parseentries.php');

/**
 * Plugin 'BibTex Publication List' for the 'si_bibtex' extension.
 *
 * @author	Stefan Siebel <siebel.stefan@gmail.com>
 * @package	TYPO3
 * @subpackage	tx_sibibtex
 */
class tx_sibibtex_pi1 extends tslib_pibase {
	var $prefixId      = 'tx_sibibtex_pi1';		// Same as class name
	var $scriptRelPath = 'pi1/class.tx_sibibtex_pi1.php';	// Path to this script relative to the extension dir.
	var $extKey        = 'si_bibtex';	// The extension key.
	var $pi_checkCHash = true;
	var $current = "";	// for grouping the entries in pi_make_list. should be put into method instead of being global
	
	/**
	 * Main method of your PlugIn
	 *
	 * @param	string		$content: The content of the PlugIn
	 * @param	array		$conf: The PlugIn Configuration
	 * @return	The content that should be displayed on the website
	 */
	function main($content,$conf)	{
		// load flexform data
		$this->pi_initPIflexForm();
		// extract display mode
		$selectedView = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'what_to_display');
		switch($selectedView) {
			case 'LIST':
				if (strstr($this->cObj->currentRecord,'tt_content')) {
					// load pids from starting point
					$conf['pidList'] = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'pages');
					// load level of recursion
					$conf['recursive'] = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'recursive');
				}
				return $this->pi_wrapInBaseClass($this->listView($content,$conf));
			break;
			case 'SINGLE':
				list($t) = explode(':',$this->cObj->currentRecord);
				$this->internal['currentTable']=$t;
				$this->internal['currentRow']=$this->cObj->data;
				return $this->pi_wrapInBaseClass($this->singleView($content,$conf));
			break;
			case 'IMPORT':
				if($this->piVars['do_upload']){
					return $this->importBibtexFile();
				} 
				return $this->pi_wrapInBaseClass($this->displayUploadForm());
			break;
			case 'SEARCH':

			break;
			default:
				return "Detected miss configuration of plugin. Please select something we should display!";
			break;
		}
	}
	
	/**
	 * Shows a list of database entries
	 *
	 * @param	string		$content: content of the PlugIn
	 * @param	array		$conf: PlugIn Configuration
	 * @return	HTML list of table entries
	 */
	function listView($content,$conf)	{
		$this->conf=$conf;	// Setting the TypoScript passed to this function in $this->conf
		$this->pi_setPiVarDefaults();
		$this->pi_loadLL();	// Loading the LOCAL_LANG values
		
		$lConf = $this->conf['listView.'];	// Local settings for the listView function
	
		if ($this->piVars['showUid'])	{	// If a single element should be displayed:
			$this->internal['currentTable'] = 'tx_sibibtex_entries';
			$this->internal['currentRow'] = $this->pi_getRecord('tx_sibibtex_entries',$this->piVars['showUid']);
	
			$content = $this->singleView($content,$conf);
			return $content;
		} else {
			//$items=array(
			//	'1'=> $this->pi_getLL('list_mode_1','Mode 1'),
			//	'2'=> $this->pi_getLL('list_mode_2','Mode 2'),
			//	'3'=> $this->pi_getLL('list_mode_3','Mode 3'),
			//);
			//if (!isset($this->piVars['pointer']))	$this->piVars['pointer']=0;
			//if (!isset($this->piVars['mode']))	$this->piVars['mode']=1;
	
			// Initializing the query parameters:
			if ($this->piVars['sort']) {
				list($this->internal['orderBy'],$this->internal['descFlag']) = explode(':',$this->piVars['sort']);
			} else {
				$this->internal['orderBy'] = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'orderBy',$sheet='s_listOptions');
				$this->internal['descFlag'] = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'orderDirection',$sheet='s_listOptions');
			}
			// Number of results to show in a listing.
			$this->internal['results_at_a_time']=t3lib_div::intInRange($lConf['results_at_a_time'],0,1000,30);
			// The maximum number of "pages" in the browse-box: "Page 1", "Page 2", etc.
			$this->internal['maxPages']=t3lib_div::intInRange($lConf['maxPages'],0,1000,2);
			
			$this->internal['searchFieldList']='uid,author,title,journal,year,volume,number,pages,month,note,editor,publisher,series,address,edition,isbn,howpublished,booktitle,organization,chapter,type,school,institution,abstract';
			$this->internal['orderByList']='uid,author,title,journal,year,volume,number,pages,month,editor,publisher,series,edition,isbn,booktitle,organization,chapter,type,school,institution,abstract';
	
			// Get number of records:
			$res = $this->pi_exec_query('tx_sibibtex_entries',1);
			list($this->internal['res_count']) = $GLOBALS['TYPO3_DB']->sql_fetch_row($res);
	
			// Make listing query, pass query to SQL database:
			$res = $this->pi_exec_query('tx_sibibtex_entries');
			$this->internal['currentTable'] = 'tx_sibibtex_entries';
	
			// Put the whole list together:
			$fullTable='';	// Clear var;
			
			// DEBUG: Output the content of $this->piVars for debug purposes. REMEMBER to comment out the IP-lock in the debug() function in t3lib/config_default.php if nothing happens when you un-comment this line!
			//$fullTable.=t3lib_div::view_array($this->piVars).$this->internal['orderBy'].":".$this->internal['descFlag'];	
	
			// Adds the mode selector.
			//$fullTable.=$this->pi_list_modeSelector($items);
	
			// Adds the whole list table
			$fullTable.=$this->pi_list_makelist($res);
	
			// Adds the search box:
			//$fullTable.=$this->pi_list_searchBox();
	
			// Adds the result browser:
			$fullTable.=$this->pi_list_browseresults();
	
			// Returns the content from the plugin.
			return $fullTable;
		}
	}


	/**
	 * Display a single item from the database
	 *
	 * @param	string		$content: The PlugIn content
	 * @param	array		$conf: The PlugIn configuration
	 * @return	HTML of a single database entry
	 */
	function singleView($content,$conf)	{
		$this->conf=$conf;
		$this->pi_setPiVarDefaults();
		$this->pi_loadLL();
		
	
		// This sets the title of the page for use in indexed search results:
		if ($this->internal['currentRow']['title'])	$GLOBALS['TSFE']->indexedDocTitle=$this->internal['currentRow']['title'];

		$template = $this->getBibtexStyle();
		// create a marker array of bibtex fields without the substitution of single templates for fields
		$markerArray = $this->createMarkerArrayOfFields($template, false);

		// extract subpart for list items
		$subpart = $this->cObj->getSubpart($template, "###SINGLE###");
		// execute substitution
		$content = $this->cObj->substituteMarkerArray($subpart, $markerArray);
	

		//$content=$this->pi_list_linkSingle($this->pi_getLL('back','Back'),0).'</p></div>'.
		//$this->pi_getEditPanel();
	
		return $content;
	}
	
	/**
	 * Returns the list of items based on the input SQL result pointer
	 *
	 * @param	pointer 	Result pointer to a SQL result which can be traversed.
	 * @param	string		Attributes for the table tag which is wrapped around the table rows containing the list
	 * @return	string		Output HTML, wrapped in tags with a class attribute 
	*/
	function pi_list_makelist($res,$tableParams='') {
		// Make list table header:
		$tRows=array();
		$this->internal['currentRow']='';
		$tRows[] = $this->pi_list_header();
		// Make list table rows
		$c=0;

		$template = $this->getBibtexStyle();
		
		while($this->internal['currentRow'] = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res))      {
			if($this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'groupEntries',$sheet='s_listOptions')) {
			switch ($this->internal['orderBy'])	{
			case 'year':
				if (!($this->current == $this->internal['currentRow']['year'])) {
					$this->current = $this->internal['currentRow']['year'];
					$mA['###GROUP###'] = $this->current;
					$s = $this->cObj->getSubpart($template, '###GROUP_SECTION###');
					$group = $this->cObj->substituteMarkerArray($s, $mA);
				} else {
					$group = "";
				}
			break;
			case 'journal':
				if (!($this->current == substr($this->internal['currentRow']['journal'],0,1))) {
					$this->current = substr($this->internal['currentRow']['journal'],0,1);
					$mA['###GROUP###'] = $this->current;
					$s = $this->cObj->getSubpart($template, '###GROUP_SECTION###');
					$group = $this->cObj->substituteMarkerArray($s, $mA);
				} else {
					$group = "";
				}
			break;
			case 'author':
				if (!($this->current == substr($this->internal['currentRow']['author'],0,1))) {
					$this->current = substr($this->internal['currentRow']['author'],0,1);
					$mA['###GROUP###'] = $this->current;
					$s = $this->cObj->getSubpart($template, '###GROUP_SECTION###');
					$group = $this->cObj->substituteMarkerArray($s, $mA);
				} else {
					$group = "";
				}
			break;
			case 'uid':
				// doing nothing... uid is unique. so making groups can become hard work
			break;
			}
			}
			$tRows[] = $group . $this->pi_list_row($c);
			$c++;
		}
		
		// create marker array
		$markerArray["###LIST_ITEM###"] = implode('',$tRows);
		// extract subpart
		$subpart = $this->cObj->getSubpart($template, "###LIST_VIEW###");
		// execute substitution
		$out = $this->cObj->substituteMarkerArray($subpart, $markerArray);

		return $out;
	}

	/**
	 * Returns a single table row for list view
	 *
	 * @param	integer		$c: Counter for odd / even behavior
	 * @return	A HTML table row
	 */
	function pi_list_row($c) {
		$editPanel = $this->pi_getEditPanel();
		if ($editPanel)	$editPanel=''.$editPanel.'';
		

		$template = $this->getBibtexStyle();
		// create formated marker array for bibtex fields
		$markerArray = $this->createMarkerArrayOfFields($template, true);
		
		// extract subpart for list items
		$subpart = $this->cObj->getSubpart($template, "###LIST_ITEMS###");
		// execute substitution
		$out = $this->cObj->substituteMarkerArray($subpart, $markerArray);
		
		
		return $out;
	}

	/**
	 * Returns a table row with column names of the table
	 *
	 * @return	A HTML table row
	 */
	function pi_list_header()	{
		return '<p'.$this->pi_classParam('sort-links').'>Sortieren nach:
				'.$this->getFieldHeader_sortLink('uid').' '
				.$this->getFieldHeader_sortLink('author').' '
				.$this->getFieldHeader_sortLink('year').' '
				.$this->getFieldHeader_sortLink('journal').'
			</p>';
	}

	/**
	 * Returns the content of a given field
	 *
	 * @param	string		$fN: name of table field
	 * @return	Value of the field
	 */
	function getFieldContent($fN)	{
		switch($fN) {
			case 'uid':
				return $this->pi_list_linkSingle($this->internal['currentRow'][$fN],$this->internal['currentRow']['uid'],1);	// The "1" means that the display of single items is CACHED! Set to zero to disable caching.
			break;
			default:
				return $this->internal['currentRow'][$fN];
			break;
		}
	}
	/**
	 * Returns the label for a fieldname from local language array
	 *
	 * @param	[type]		$fN: ...
	 * @return	[type]		...
	 */
	function getFieldHeader($fN)	{
		switch($fN) {
			case "title":
				return $this->pi_getLL('listFieldHeader_title','<em>title</em>');
			break;
			default:
				return $this->pi_getLL('listFieldHeader_'.$fN,'['.$fN.']');
			break;
		}
	}
	
	/**
	 * Returns a sorting link for a column header
	 *
	 * @param	string		$fN: Fieldname
	 * @return	The fieldlabel wrapped in link that contains sorting vars
	 */
	function getFieldHeader_sortLink($fN)	{
		return $this->pi_linkTP_keepPIvars($this->getFieldHeader($fN),array('sort'=>$fN.':'.($this->internal['descFlag']?0:1)));
	}

	/**
	 * Creates a marker Array for all bibtex fields supported
	 *
	 * @param	String	The Template File
	 * @param 	Bool	With substition of templates for single fields or without.
	 * @return	The Marker Array.
	 */
	function createMarkerArrayOfFields($template, $substitution) {
		$markerArray["###UID###"] = $this->getFieldContent('uid');
		if ($substitution == true) {
			$subpart = $this->cObj->getSubpart($template, "###TUID###");
			$markerArray["###UID###"] = $this->cObj->substituteMarkerArray($subpart, $markerArray);
		}

		$fields = array("author", "title", "journal", "year", "volume", "number", "pages", "month",  "note", "editor", "publisher", "series", "address", "edition", "isbn", "howpublished", "booktitle", "organization", "chapter", "type", "school", "institution", "abstract");

		foreach ($fields as $value) {
			if ($this->getFieldContent($value)) { 
				$markerArray["###".mb_strtoupper($value)."###"] = $this->getFieldContent($value);
			} else {
				$markerArray["###".mb_strtoupper($value)."###"] = "";
			}
			if ($substitution == true) {
				$subpart = $this->cObj->getSubpart($template, "###T".mb_strtoupper($value)."###");
				$markerArray["###".mb_strtoupper($value)."###"] = $this->cObj->substituteMarkerArray($subpart, $markerArray);
			}
		}
		return $markerArray;
	}

	/**
	 * Get bibtex style which is configured
	 *
	 * @return	The BibTexStyle
	 */
	function getBibtexStyle() {
		$bibtexStyle = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'bibtexStyle', $sheet='s_listOptions');
	
		switch ($bibtexStyle) {
			case 'plain':
				$template = $this->cObj->fileResource('typo3conf/ext/si_bibtex/pi1/templates/template_plain.html');
			break;
			case 'named':
				$template = $this->cObj->fileResource('typo3conf/ext/si_bibtex/pi1/templates/template_named.html');
			break;
			case 'alpha':
				$template = $this->cObj->fileResource('typo3conf/ext/si_bibtex/pi1/templates/template_alpha.html');
			break;
		}
		return $template;
	}

	/**
	 * Imports bibtex file and stores values in database table
	 *
	 * @return Several information about import process
	 */
	function importBibtexFile() {

		// TODO	check file extension "bib" before importing.

		// should i check for duplicates or not?!
		$checkDup = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'preventDuplicate',$sheet='s_importOptions');

		// move uploaded file to typo3temp in order to work in safe-mode.		
		$url = t3lib_div::upload_to_tempfile($_FILES[$this->prefixId]['tmp_name']['fileName']);
		if ($url == "") {
			return "ERROR: Can't copy file to temporary position. Stopping operation";
		}

		// copy content of uploaded file to var
		$fileContent = t3lib_div::getURL($url, 0);
		$charset = mb_detect_encoding($fileContent);
		$fileContent = mb_convert_encoding($fileContent, 'utf-8', $charset);

			

		// delete uploaded file
		$status = t3lib_div::unlink_tempfile($url);
		if ($status == false) $warning = "WARNING: Can't delete temporary file. But I can continue...<br />";

		// create new instance of bibtex parser
		$parse = t3lib_div::makeInstance('tx_sibibtex_parseentries');
		// load the bibtex data into that object
		$parse->loadBibtexString($fileContent);
		// extract the entries ...
		$parse->extractEntries();
		// and save them in an array
		list($preamble, $strings, $entries, $untx_sibibtex_entriesdefinedStrings) = $parse->returnArrays();
		
		// create array with already existing entries to prevent duplicate entries
		// in database later on
		if ($checkDup) {
			$select_fields = 'pid, author, title, journal, year, volume';
			$from_table = 'tx_sibibtex_entries';
			$where_clause = '';	// all
			$res = $GLOBALS['TYPO3_DB']->exec_SELECTquery($select_fields, $from_table, $where_clause);
			$i = 0;
			$existingValues = array();
			while ($row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res)) {
				$values = "";
				foreach ($row as $field) {
					$values .= $field;
				}
				$existingValues[$i] = md5(mb_strtolower($values));
				$i++;
			}
		}

		// save each entry in database
		$entryCounter = 0;	// counts added entries
		$dupCounter = 0;	// counts duplicate entries
		foreach ($entries as $bibEntry) {
			$dbArray = array('id_reference' => $bibEntry['bibtexEntryType'],
					'author' => $bibEntry['author'],
					'title' => $bibEntry['title'],
					'pid' => $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'pages'),
					'journal' => $bibEntry['journal'],
					'year' => $bibEntry['year'],
					'volume' => $bibEntry['volume'],
					'number' => $bibEntry['number'],
					'pages' => $bibEntry['pages'],
					'month' => $bibEntry['month'],
					'note' => $bibEntry['note'],
					'editor' => $bibEntry['editor'],
					'publisher' => $bibEntry['publisher'],
					'series' => $bibEntry['series'],
					'address' => $bibEntry['address'],
					'edition' => $bibEntry['edition'],
					'isbn' => $bibEntry['isbn'],
					'howpublished' => $bibEntry['howpublished'],
					'booktitle' => $bibEntry['booktitle'],
					'organization' => $bibEntry['organization'],
					'chapter' => $bibEntry['chapter'],
					'type' => $bibEntry['type'],
					'school' => $bibEntry['school'],
					'institution' => $bibEntry['institution'],
					'abstract' => $bibEntry['abstract'],
					);
			// calculate hash value of current item
			if ($checkDup) $currentHash = md5(mb_strtolower($dbArray['pid'].$bibEntry['author'].$bibEntry['title'].$bibEntry['journal'].$bibEntry['year'].$bibEntry['volume']));

			// save in
			if ($checkDup && in_array($currentHash, $existingValues, false)) {
				$doubles .= "Didn't import <em><small>" . $bibEntry['title'] . "</small></em>. Item already exists in database!<br />";
				$dupCounter++;
			} else {
				$status = $GLOBALS['TYPO3_DB']->exec_INSERTquery('tx_sibibtex_entries', $dbArray);
				if ($status) $entryCounter++;
			}
			
		}
		// build the return message and well... return it.
		$msg = $warning .($warning != "" ? "<br />" : ""). $doubles . ($doubles != "" ? "<br />" : "") . "Imported <strong>" . $entryCounter . "</strong> entries.<br /><strong>".($checkDup ? $dupCounter."</strong> already existing entries!" : "");
		return $msg;
		
	}

	/**
	 * The Upload form for the import function.
	 *
	 * @return The Upload Form
	 */
	function displayUploadForm() {
		// TODO: evtl. abändern wie beschrieben auf seite 590 galileo buch
		$content = '<form enctype="multipart/form-data" method="POST">
					<input name="'.$this->prefixId.'[fileName]" type="file"><br />
					<input type="submit" name="'.$this->prefixId.'[do_upload]" value="Upload!"><br>
					</form>';
		return $content;
	}
}



if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/si_bibtex/pi1/class.tx_sibibtex_pi1.php'])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/si_bibtex/pi1/class.tx_sibibtex_pi1.php']);
}



?>