<?php
if (!defined ('TYPO3_MODE')) 	die ('Access denied.');

$TCA["tx_sibibtex_references"] = array (
	"ctrl" => $TCA["tx_sibibtex_references"]["ctrl"],
	"interface" => array (
		"showRecordFieldList" => "sys_language_uid,l18n_parent,l18n_diffsource,starttime,endtime,title"
	),
	"feInterface" => $TCA["tx_sibibtex_references"]["feInterface"],
	"columns" => array (
		'sys_language_uid' => array (		
			'exclude' => 1,
			'label'  => 'LLL:EXT:lang/locallang_general.xml:LGL.language',
			'config' => array (
				'type'                => 'select',
				'foreign_table'       => 'sys_language',
				'foreign_table_where' => 'ORDER BY sys_language.title',
				'items' => array(
					array('LLL:EXT:lang/locallang_general.xml:LGL.allLanguages', -1),
					array('LLL:EXT:lang/locallang_general.xml:LGL.default_value', 0)
				)
			)
		),
		'l18n_parent' => array (		
			'displayCond' => 'FIELD:sys_language_uid:>:0',
			'exclude'     => 1,
			'label'       => 'LLL:EXT:lang/locallang_general.xml:LGL.l18n_parent',
			'config'      => array (
				'type'  => 'select',
				'items' => array (
					array('', 0),
				),
				'foreign_table'       => 'tx_sibibtex_references',
				'foreign_table_where' => 'AND tx_sibibtex_references.pid=###CURRENT_PID### AND tx_sibibtex_references.sys_language_uid IN (-1,0)',
			)
		),
		'l18n_diffsource' => array (		
			'config' => array (
				'type' => 'passthrough'
			)
		),
		'starttime' => array (		
			'exclude' => 1,
			'label'   => 'LLL:EXT:lang/locallang_general.xml:LGL.starttime',
			'config'  => array (
				'type'     => 'input',
				'size'     => '8',
				'max'      => '20',
				'eval'     => 'date',
				'default'  => '0',
				'checkbox' => '0'
			)
		),
		'endtime' => array (		
			'exclude' => 1,
			'label'   => 'LLL:EXT:lang/locallang_general.xml:LGL.endtime',
			'config'  => array (
				'type'     => 'input',
				'size'     => '8',
				'max'      => '20',
				'eval'     => 'date',
				'checkbox' => '0',
				'default'  => '0',
				'range'    => array (
					'upper' => mktime(0, 0, 0, 12, 31, 2020),
					'lower' => mktime(0, 0, 0, date('m')-1, date('d'), date('Y'))
				)
			)
		),
		"title" => Array (		
			"exclude" => 1,		
			"label" => "LLL:EXT:si_bibtex/locallang_db.xml:tx_sibibtex_references.title",		
			"config" => Array (
				"type" => "input",	
				"size" => "30",
			)
		),
	),
	"types" => array (
		"0" => array("showitem" => "sys_language_uid;;;;1-1-1, l18n_parent, l18n_diffsource, starttime, endtime, title;;;;2-2-2")
	),
	"palettes" => array (
		"1" => array("showitem" => "")
	)
);



$TCA["tx_sibibtex_entries"] = array (
	"ctrl" => $TCA["tx_sibibtex_entries"]["ctrl"],
	"interface" => array (
		"showRecordFieldList" => "sys_language_uid,l18n_parent,l18n_diffsource,hidden,starttime,endtime,id_reference,author,title,journal,year,volume,number,pages,month,note,editor,publisher,series,address,edition,isbn,howpublished,booktitle,organization,chapter,type,school,institution"
	),
	"feInterface" => $TCA["tx_sibibtex_entries"]["feInterface"],
	"columns" => array (
		'sys_language_uid' => array (		
			'exclude' => 1,
			'label'  => 'LLL:EXT:lang/locallang_general.xml:LGL.language',
			'config' => array (
				'type'                => 'select',
				'foreign_table'       => 'sys_language',
				'foreign_table_where' => 'ORDER BY sys_language.title',
				'items' => array(
					array('LLL:EXT:lang/locallang_general.xml:LGL.allLanguages', -1),
					array('LLL:EXT:lang/locallang_general.xml:LGL.default_value', 0)
				)
			)
		),
		'l18n_parent' => array (		
			'displayCond' => 'FIELD:sys_language_uid:>:0',
			'exclude'     => 1,
			'label'       => 'LLL:EXT:lang/locallang_general.xml:LGL.l18n_parent',
			'config'      => array (
				'type'  => 'select',
				'items' => array (
					array('', 0),
				),
				'foreign_table'       => 'tx_sibibtex_entries',
				'foreign_table_where' => 'AND tx_sibibtex_entries.pid=###CURRENT_PID### AND tx_sibibtex_entries.sys_language_uid IN (-1,0)',
			)
		),
		'l18n_diffsource' => array (		
			'config' => array (
				'type' => 'passthrough'
			)
		),
		'hidden' => array (		
			'exclude' => 1,
			'label'   => 'LLL:EXT:lang/locallang_general.xml:LGL.hidden',
			'config'  => array (
				'type'    => 'check',
				'default' => '0'
			)
		),
		'starttime' => array (		
			'exclude' => 1,
			'label'   => 'LLL:EXT:lang/locallang_general.xml:LGL.starttime',
			'config'  => array (
				'type'     => 'input',
				'size'     => '8',
				'max'      => '20',
				'eval'     => 'date',
				'default'  => '0',
				'checkbox' => '0'
			)
		),
		'endtime' => array (		
			'exclude' => 1,
			'label'   => 'LLL:EXT:lang/locallang_general.xml:LGL.endtime',
			'config'  => array (
				'type'     => 'input',
				'size'     => '8',
				'max'      => '20',
				'eval'     => 'date',
				'checkbox' => '0',
				'default'  => '0',
				'range'    => array (
					'upper' => mktime(0, 0, 0, 12, 31, 2020),
					'lower' => mktime(0, 0, 0, date('m')-1, date('d'), date('Y'))
				)
			)
		),
		"id_reference" => Array (		
			"exclude" => 1,		
			"label" => "LLL:EXT:si_bibtex/locallang_db.xml:tx_sibibtex_entries.id_reference",		
			"config" => Array (
				"type" => "group",	
				"internal_type" => "db",	
				"allowed" => "tx_sibibtex_references",	
				"size" => 1,	
				"minitems" => 0,
				"maxitems" => 1,
			)
		),
		"author" => Array (		
			"exclude" => 1,		
			"label" => "LLL:EXT:si_bibtex/locallang_db.xml:tx_sibibtex_entries.author",		
			"config" => Array (
				"type" => "text",
				"cols" => "30",	
				"rows" => "4",
			)
		),
		"title" => Array (		
			"exclude" => 1,		
			"label" => "LLL:EXT:si_bibtex/locallang_db.xml:tx_sibibtex_entries.title",		
			"config" => Array (
				"type" => "input",	
				"size" => "30",	
				"eval" => "trim",
			)
		),
		"journal" => Array (		
			"exclude" => 1,		
			"label" => "LLL:EXT:si_bibtex/locallang_db.xml:tx_sibibtex_entries.journal",		
			"config" => Array (
				"type" => "input",	
				"size" => "30",	
				"eval" => "trim",
			)
		),
		"year" => Array (		
			"exclude" => 1,		
			"label" => "LLL:EXT:si_bibtex/locallang_db.xml:tx_sibibtex_entries.year",		
			"config" => Array (
				"type" => "input",	
				"size" => "30",
			)
		),
		"volume" => Array (		
			"exclude" => 1,		
			"label" => "LLL:EXT:si_bibtex/locallang_db.xml:tx_sibibtex_entries.volume",		
			"config" => Array (
				"type" => "input",	
				"size" => "30",
			)
		),
		"number" => Array (		
			"exclude" => 1,		
			"label" => "LLL:EXT:si_bibtex/locallang_db.xml:tx_sibibtex_entries.number",		
			"config" => Array (
				"type" => "input",	
				"size" => "30",
			)
		),
		"pages" => Array (		
			"exclude" => 1,		
			"label" => "LLL:EXT:si_bibtex/locallang_db.xml:tx_sibibtex_entries.pages",		
			"config" => Array (
				"type" => "input",	
				"size" => "30",
			)
		),
		"month" => Array (		
			"exclude" => 1,		
			"label" => "LLL:EXT:si_bibtex/locallang_db.xml:tx_sibibtex_entries.month",		
			"config" => Array (
				"type" => "input",	
				"size" => "30",
			)
		),
		"note" => Array (		
			"exclude" => 1,		
			"label" => "LLL:EXT:si_bibtex/locallang_db.xml:tx_sibibtex_entries.note",		
			"config" => Array (
				"type" => "text",
				"cols" => "30",	
				"rows" => "5",
			)
		),
		"editor" => Array (		
			"exclude" => 1,		
			"label" => "LLL:EXT:si_bibtex/locallang_db.xml:tx_sibibtex_entries.editor",		
			"config" => Array (
				"type" => "input",	
				"size" => "30",	
				"eval" => "trim",
			)
		),
		"publisher" => Array (		
			"exclude" => 1,		
			"label" => "LLL:EXT:si_bibtex/locallang_db.xml:tx_sibibtex_entries.publisher",		
			"config" => Array (
				"type" => "input",	
				"size" => "30",	
				"eval" => "trim",
			)
		),
		"series" => Array (		
			"exclude" => 1,		
			"label" => "LLL:EXT:si_bibtex/locallang_db.xml:tx_sibibtex_entries.series",		
			"config" => Array (
				"type" => "input",	
				"size" => "30",
			)
		),
		"address" => Array (		
			"exclude" => 1,		
			"label" => "LLL:EXT:si_bibtex/locallang_db.xml:tx_sibibtex_entries.address",		
			"config" => Array (
				"type" => "text",
				"cols" => "30",	
				"rows" => "5",
			)
		),
		"edition" => Array (		
			"exclude" => 1,		
			"label" => "LLL:EXT:si_bibtex/locallang_db.xml:tx_sibibtex_entries.edition",		
			"config" => Array (
				"type" => "input",	
				"size" => "30",
			)
		),
		"isbn" => Array (		
			"exclude" => 1,		
			"label" => "LLL:EXT:si_bibtex/locallang_db.xml:tx_sibibtex_entries.isbn",		
			"config" => Array (
				"type" => "input",	
				"size" => "30",	
				"eval" => "trim",
			)
		),
		"howpublished" => Array (		
			"exclude" => 1,		
			"label" => "LLL:EXT:si_bibtex/locallang_db.xml:tx_sibibtex_entries.howpublished",		
			"config" => Array (
				"type" => "text",
				"cols" => "30",	
				"rows" => "5",
			)
		),
		"booktitle" => Array (		
			"exclude" => 1,		
			"label" => "LLL:EXT:si_bibtex/locallang_db.xml:tx_sibibtex_entries.booktitle",		
			"config" => Array (
				"type" => "input",	
				"size" => "30",	
				"eval" => "trim",
			)
		),
		"organization" => Array (		
			"exclude" => 1,		
			"label" => "LLL:EXT:si_bibtex/locallang_db.xml:tx_sibibtex_entries.organization",		
			"config" => Array (
				"type" => "input",	
				"size" => "30",
			)
		),
		"chapter" => Array (		
			"exclude" => 1,		
			"label" => "LLL:EXT:si_bibtex/locallang_db.xml:tx_sibibtex_entries.chapter",		
			"config" => Array (
				"type" => "input",	
				"size" => "30",
			)
		),
		"type" => Array (		
			"exclude" => 1,		
			"label" => "LLL:EXT:si_bibtex/locallang_db.xml:tx_sibibtex_entries.type",		
			"config" => Array (
				"type" => "input",	
				"size" => "30",
			)
		),
		"school" => Array (		
			"exclude" => 1,		
			"label" => "LLL:EXT:si_bibtex/locallang_db.xml:tx_sibibtex_entries.school",		
			"config" => Array (
				"type" => "input",	
				"size" => "30",	
				"eval" => "trim",
			)
		),
		"institution" => Array (		
			"exclude" => 1,		
			"label" => "LLL:EXT:si_bibtex/locallang_db.xml:tx_sibibtex_entries.institution",		
			"config" => Array (
				"type" => "input",	
				"size" => "30",	
				"eval" => "trim",
			)
		),
	),
	"types" => array (
		"0" => array("showitem" => "sys_language_uid;;;;1-1-1, l18n_parent, l18n_diffsource, hidden;;1, id_reference, author, title;;;;2-2-2, journal;;;;3-3-3, year, volume, number, pages, month, note, editor, publisher, series, address, edition, isbn, howpublished, booktitle, organization, chapter, type, school, institution")
	),
	"palettes" => array (
		"1" => array("showitem" => "starttime, endtime")
	)
);
?>